OGRE: Ogre::TextAreaOverlayElement Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::TextAreaOverlayElement Class Reference
Optional Components » Overlay

This class implements an overlay element which contains simple unformatted text. More...

`#include <OgreTextAreaOverlayElement.h>`

Inheritance diagram for Ogre::TextAreaOverlayElement:
[legend]

## Public Types
enum | Alignment { Left , Right , Center }
Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }

## Public Member Functions
| TextAreaOverlayElement (const String &name)
| Constructor.
virtual | ~TextAreaOverlayElement ()
void | _releaseManualHardwareResources () override
| Notifies that hardware resources were lost.
void | _restoreManualHardwareResources () override
| Notifies that hardware resources should be restored.
void | _update (void) override
| Overridden from OverlayElement.
Alignment | getAlignment () const
Real | getCharHeight () const
const ColourValue & | getColour (void) const override
| Gets the colour of the text.
const ColourValue & | getColourBottom (void) const
| Gets the colour of the bottom of the letters.
const ColourValue & | getColourTop (void) const
| Gets the colour of the top of the letters.
const FontPtr & | getFont () const
const String & | getFontName () const
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
void | getRenderOperation (RenderOperation &op) override
| Gets the render operation required to send this object to the frame buffer.
Real | getSpaceWidth () const
const String & | getTypeName (void) const override
| Gets the type name of the element.
void | initialise (void) override
| Initialise gui element.
void | setAlignment (Alignment a)
void | setCaption (const DisplayString &text) override
| Sets the caption on elements that support it.
void | setCharHeight (Real height)
void | setColour (const ColourValue &col) override
| Sets the colour of the text.
void | setColourBottom (const ColourValue &col)
| Sets the colour of the bottom of the letters.
void | setColourTop (const ColourValue &col)
| Sets the colour of the top of the letters.
void | setFontName (const String &font, const String &group=DEFAULT_RESOURCE_GROUP)
void | setMetricsMode (GuiMetricsMode gmm) override
| Overridden from OverlayElement.
void | setSpaceWidth (Real width)
Public Member Functions inherited from Ogre::OverlayElement
| OverlayElement (const String &name)
| Constructor: do not call direct, use OverlayManager::createElement.
virtual | ~OverlayElement ()
virtual void | _getClippingRegion (RealRect &clippingRegion)
| Gets the clipping region of the element.
virtual Real | _getDerivedLeft (void)
| Gets the 'left' position as derived from own left and that of parents.
virtual Real | _getDerivedTop (void)
| Gets the 'top' position as derived from own left and that of parents.
Real | _getHeight (void) const
| Gets the height of this element in relation to the screen (where 1.0 = screen height).
Real | _getLeft (void) const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
virtual Real | _getRelativeHeight (void)
| Gets the 'height' as derived from own height and metrics mode.
virtual Real | _getRelativeWidth (void)
| Gets the 'width' as derived from own width and metrics mode.
Real | _getTop (void) const
| Gets the top of this element in relation to the screen (where 0 = far top, 1.0 = far bottom).
Real | _getWidth (void) const
| Gets the width of this element in relation to the screen (where 1.0 = screen width).
virtual void | _notifyParent (OverlayContainer *parent, Overlay *overlay)
| Internal method for notifying the GUI element of it's parent and ultimate overlay.
virtual void | _notifyViewport ()
| Internal method to notify the element when the viewport of parent overlay has changed.
virtual void | _notifyWorldTransforms (const Matrix4 &xform)
| Internal method to notify the element when it's world transform of parent overlay has changed.
virtual ushort | _notifyZOrder (ushort newZOrder)
| Internal method to notify the element when Z-order of parent overlay has changed.
virtual void | _positionsOutOfDate (void)
| Tell the object to recalculate.
void | _setDimensions (Real width, Real height)
| Sets the width and height of this element in relation to the screen (where 1.0 = screen width/height).
void | _setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen height).
void | _setLeft (Real left)
| Sets the left of this element in relation to the screen (where 1.0 = screen width).
void | _setParent (OverlayContainer *parent)
void | _setPosition (Real left, Real top)
| Sets the left and top of this element in relation to the screen (where 1.0 = screen width/height).
void | _setTop (Real top)
| Sets the top of this element in relation to the screen (where 1.0 = screen height).
void | _setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width).
virtual void | _updateFromParent (void)
| Updates this elements transform based on it's parent.
virtual void | _updateRenderQueue (RenderQueue *queue)
| Internal method to put the contents onto the render queue.
virtual OverlayElement * | clone (const String &instanceName)
virtual bool | contains (Real x, Real y) const
| Returns true if xy is within the constraints of the component.
virtual void | copyFromTemplate (OverlayElement *templateOverlay)
virtual OverlayElement * | findElementAt (Real x, Real y)
| Returns true if xy is within the constraints of the component.
const DisplayString & | getCaption (void) const
| Gets the caption for this element.
Real | getHeight (void) const
| Gets the height of this element in relation to the current GuiMetricsMode.
GuiHorizontalAlignment | getHorizontalAlignment (void) const
| Gets the horizontal alignment for this element.
Real | getLeft (void) const
| Gets the left of this element in relation to the current GuiMetricsMode.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
virtual const String & | getMaterialName (void) const
| Gets the name of the material this element uses.
GuiMetricsMode | getMetricsMode (void) const
| Retrieves the current settings of how the element metrics are interpreted.
const String & | getName (void) const
| Gets the name of this overlay.
OverlayContainer * | getParent ()
| Returns the parent container.
Real | getSquaredViewDepth (const Camera *cam) const override
| Returns the squared distance between the camera and this renderable.
Real | getTop (void) const
| Gets the top of this element in relation to the current GuiMetricsMode (where 0 = top).
GuiVerticalAlignment | getVerticalAlignment (void) const
| Gets the vertical alignment for this element.
Real | getWidth (void) const
| Gets the width of this element in relation to the current GuiMetricsMode.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
ushort | getZOrder () const
| Returns the zOrder of the element.
void | hide (void)
| Hides this element if it was visible.
bool | isCloneable () const
virtual bool | isContainer () const
| returns false as this class is not a container type
bool | isEnabled () const
virtual bool | isKeyEnabled () const
bool | isVisible (void) const
| Returns whether or not the element is visible.
void | setCloneable (bool c)
void | setDimensions (Real width, Real height)
| Sets the dimensions of this element in relation to the current GuiMetricsMode.
void | setEnabled (bool b)
void | setHeight (Real height)
| Sets the height of this element in relation to the current GuiMetricsMode.
virtual void | setHorizontalAlignment (GuiHorizontalAlignment gha)
| Sets the horizontal origin for this element.
void | setLeft (Real left)
| Sets the left of this element in relation to the current GuiMetricsMode.
void | setMaterial (const MaterialPtr &mat)
| Sets the the material this element will use.
void | setMaterialName (const String &matName, const String &group=DEFAULT_RESOURCE_GROUP)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setPosition (Real left, Real top)
| Sets the position of the top-left corner in relation to the current GuiMetricsMode (where 0 = top).
void | setTop (Real Top)
| Sets the top of this element in relation to the current GuiMetricsMode (where 0 = top).
virtual void | setVerticalAlignment (GuiVerticalAlignment gva)
| Sets the vertical origin for this element.
void | setVisible (bool visible)
| Shows or hides this element.
void | setWidth (Real width)
| Sets the width of this element in relation to the current GuiMetricsMode.
void | show (void)
| Shows this element if it was hidden.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Static Public Attributes inherited from Ogre::OverlayElement
static const String & | DEFAULT_RESOURCE_GROUP

## Detailed Description

This class implements an overlay element which contains simple unformatted text.

## Member Enumeration Documentation

## ◆ Alignment

enum Ogre::TextAreaOverlayElement::Alignment

Enumerator
Left |
Right |
Center |

## Constructor & Destructor Documentation

## ◆ TextAreaOverlayElement()

Ogre::TextAreaOverlayElement::TextAreaOverlayElement | ( | const String & | name | ) |

Constructor.

## ◆ ~TextAreaOverlayElement()

virtual Ogre::TextAreaOverlayElement::~TextAreaOverlayElement | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ initialise()

void Ogre::TextAreaOverlayElement::initialise | ( | void |  | ) |
| overridevirtual

Initialise gui element.

Implements Ogre::OverlayElement.

## ◆ _releaseManualHardwareResources()

void Ogre::TextAreaOverlayElement::_releaseManualHardwareResources | ( |  | ) |
| overridevirtual

Notifies that hardware resources were lost.

Reimplemented from Ogre::OverlayElement.

## ◆ _restoreManualHardwareResources()

void Ogre::TextAreaOverlayElement::_restoreManualHardwareResources | ( |  | ) |
| overridevirtual

Notifies that hardware resources should be restored.

Reimplemented from Ogre::OverlayElement.

## ◆ setCaption()

void Ogre::TextAreaOverlayElement::setCaption | ( | const DisplayString & | text | ) |
| overridevirtual

Sets the caption on elements that support it.

This property doesn't do something on all elements, just those that support it. However, being a common requirement it is in the top-level interface to avoid having to set it via the StringInterface all the time.

Reimplemented from Ogre::OverlayElement.

## ◆ setCharHeight()

void Ogre::TextAreaOverlayElement::setCharHeight | ( | Real | height | ) |

## ◆ getCharHeight()

Real Ogre::TextAreaOverlayElement::getCharHeight | ( |  | ) | const

## ◆ setSpaceWidth()

void Ogre::TextAreaOverlayElement::setSpaceWidth | ( | Real | width | ) |

## ◆ getSpaceWidth()

Real Ogre::TextAreaOverlayElement::getSpaceWidth | ( |  | ) | const

## ◆ setFontName()

void Ogre::TextAreaOverlayElement::setFontName | ( | const String & | font,
|  | const String & | group = DEFAULT_RESOURCE_GROUP )

References Ogre::OverlayElement::DEFAULT_RESOURCE_GROUP.

## ◆ getFontName()

const String & Ogre::TextAreaOverlayElement::getFontName | ( |  | ) | const

Deprecated
  use getFont()

## ◆ getFont()

const FontPtr & Ogre::TextAreaOverlayElement::getFont | ( |  | ) | const
| inline

## ◆ getTypeName()

const String & Ogre::TextAreaOverlayElement::getTypeName | ( | void |  | ) | const
| overridevirtual

Gets the type name of the element.

All concrete subclasses must implement this.

Implements Ogre::OverlayElement.

## ◆ getMaterial()

const MaterialPtr & Ogre::TextAreaOverlayElement::getMaterial | ( | void |  | ) | const
| overridevirtual

Retrieves a weak reference to the material this renderable object uses.

Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Reimplemented from Ogre::OverlayElement.

## ◆ getRenderOperation()

void Ogre::TextAreaOverlayElement::getRenderOperation | ( | RenderOperation & | op | ) |
| overridevirtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ setColour()

void Ogre::TextAreaOverlayElement::setColour | ( | const ColourValue & | col | ) |
| overridevirtual

Sets the colour of the text.

This method establishes a constant colour for the entire text. Also see setColourBottom and setColourTop which allow you to set a colour gradient.

Reimplemented from Ogre::OverlayElement.

## ◆ getColour()

const ColourValue & Ogre::TextAreaOverlayElement::getColour | ( | void |  | ) | const
| overridevirtual

Gets the colour of the text.

Reimplemented from Ogre::OverlayElement.

## ◆ setColourBottom()

void Ogre::TextAreaOverlayElement::setColourBottom | ( | const ColourValue & | col | ) |

Sets the colour of the bottom of the letters.

By setting a separate top and bottom colour, you can create a text area which has a graduated colour effect to it.

## ◆ getColourBottom()

const ColourValue & Ogre::TextAreaOverlayElement::getColourBottom | ( | void |  | ) | const

Gets the colour of the bottom of the letters.

## ◆ setColourTop()

void Ogre::TextAreaOverlayElement::setColourTop | ( | const ColourValue & | col | ) |

Sets the colour of the top of the letters.

By setting a separate top and bottom colour, you can create a text area which has a graduated colour effect to it.

## ◆ getColourTop()

const ColourValue & Ogre::TextAreaOverlayElement::getColourTop | ( | void |  | ) | const

Gets the colour of the top of the letters.

## ◆ setAlignment()

void Ogre::TextAreaOverlayElement::setAlignment | ( | Alignment | a | ) |
| inline

## ◆ getAlignment()

Alignment Ogre::TextAreaOverlayElement::getAlignment | ( |  | ) | const
| inline

## ◆ setMetricsMode()

void Ogre::TextAreaOverlayElement::setMetricsMode | ( | GuiMetricsMode | gmm | ) |
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

## ◆ _update()

void Ogre::TextAreaOverlayElement::_update | ( | void |  | ) |
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

The documentation for this class was generated from the following file:

- OgreTextAreaOverlayElement.h